from enum import StrEnum

class Key:
    """Defines valid keys in OpenAI."""
    ARGUMENTS: str
    CALL_ID: str
    CONTAINER: str
    CONTENT: str
    DEFAULT: str
    DEFS: str
    EFFORT: str
    FILE_DATA: str
    FILENAME: str
    FORMAT: str
    FUNCTION: str
    ID: str
    IMAGE_URL: str
    INCLUDE: str
    INCOMPLETE_DETAILS: str
    JSON_SCHEMA: str
    NAME: str
    OUTPUT: str
    PARAMETERS: str
    REASON: str
    REASONING: str
    ROLE: str
    SCHEMA: str
    REQUIRED: str
    STATUS: str
    STRICT: str
    SUMMARY: str
    TEXT: str
    TITLE: str
    TOOLS: str
    TYPE: str

class InputType:
    """Defines valid input types in OpenAI."""
    AUTO: str
    CODE_INTERPRETER: str
    CODE_INTERPRETER_CALL_OUTPUTS: str
    FUNCTION: str
    FUNCTION_CALL: str
    FUNCTION_CALL_OUTPUT: str
    INPUT_FILE: str
    INPUT_IMAGE: str
    INPUT_TEXT: str
    JSON_SCHEMA: str
    NULL: str
    OUTPUT_TEXT: str
    REASONING: str
    SUMMARY_TEXT: str

class OutputType:
    """Defines valid output types in OpenAI."""
    CODE_INTERPRETER_CALL: str
    CODE_INTERPRETER_CALL_DELTA: str
    COMPLETED: str
    CONTAINER_FILE_CITATION: str
    FUNCTION_CALL: str
    IMAGE: str
    INCOMPLETE: str
    ITEM_DONE: str
    MESSAGE: str
    REASONING: str
    REASONING_DELTA: str
    TEXT_DELTA: str

class ReasoningEffort(StrEnum):
    """Defines the reasoning effort for reasoning models."""
    HIGH = 'high'
    MEDIUM = 'medium'
    LOW = 'low'

class ReasoningSummary(StrEnum):
    """Defines the reasoning summary for reasoning models."""
    AUTO = 'auto'
    DETAILED = 'detailed'
